/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <page/mem.h>
#include <page/mem/ops.h>
#include <page/mem/types.h>
#include <page/types.h>
#include <stddef.h>
#include <stdlib.h>

struct page *page_mem_alloc(const unsigned long addr)
{
    struct page *const ret = malloc(sizeof *ret);
    struct page_prv *const prv = malloc(sizeof *prv);
    const unsigned long start = addr - (addr % sizeof prv->buf);

    if (!ret || !prv)
        goto failure;

    *prv = (const struct page_prv){0};
    *ret = (const struct page)
    {
        .sz = sizeof prv->buf,
        .ops = &page_mem_ops,
        .addr = start,
        .prv = prv
    };

    return ret;

failure:
    free(prv);
    free(ret);
    return NULL;
}
